package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;
    public static boolean dontPause;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        if (!dontPause)
            BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        else
            BA.LogInfo("** Activity (main) Pause event (activity is not paused). **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        if (!dontPause) {
            processBA.setActivityPaused(true);
            mostCurrent = null;
        }

        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public b4a.example.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime}));}
anywheresoftware.b4a.objects.CSBuilder _cs = null;
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Try";
try {RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="Activity.LoadLayout(\"Layout\")";
mostCurrent._activity.LoadLayout("Layout",mostCurrent.activityBA);
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="Dim cs As CSBuilder";
_cs = new anywheresoftware.b4a.objects.CSBuilder();
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="cs.Initialize";
_cs.Initialize();
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="cs.Append(\"B4A – The simple way to develop nativ";
_cs.Append(BA.ObjectToCharSequence("B4A – The simple way to develop native Android apps"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="cs.Append(\"B4A includes all the features needed";
_cs.Append(BA.ObjectToCharSequence("B4A includes all the features needed to quickly develop any type of Android app."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="cs.Append(\"B4A is used by tens of thousands of d";
_cs.Append(BA.ObjectToCharSequence("B4A is used by tens of thousands of developers from all over the world, including companies such as NASA, HP, IBM and others."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="cs.Append(\"Together with B4i you can easily deve";
_cs.Append(BA.ObjectToCharSequence("Together with B4i you can easily develop applications for both Android and iOS."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="cs.Append(\"B4A is 100% free.\" & Chr(10))";
_cs.Append(BA.ObjectToCharSequence("B4A is 100% free."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="cs.Clickable(\"cs\", 1).Underline.Bold.Color(Color";
_cs.Clickable(processBA,"cs",(Object)(1)).Underline().Bold().Color(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (70),(int) (130),(int) (180))).Append(BA.ObjectToCharSequence("DOWNLOAD B4A FULL VERSION"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10))))).PopAll();
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="cs.Append(\"Make sure to follow the instructions";
_cs.Append(BA.ObjectToCharSequence("Make sure to follow the instructions below. They are not complicated and include several components that are required in order to get started."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="cs.Append(\"Consider supporting B4A by contributi";
_cs.Append(BA.ObjectToCharSequence("Consider supporting B4A by contributing to its development: $10 $20 $40 $100"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="cs.Append(\"Installation\" & Chr(10))";
_cs.Append(BA.ObjectToCharSequence("Installation"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="cs.Append(\"1.Oracle Java 8 or OpenJDK 11/14 (rec";
_cs.Append(BA.ObjectToCharSequence("1.Oracle Java 8 or OpenJDK 11/14 (recommended)"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="cs.Append(\"Download one of the following JDKs. N";
_cs.Append(BA.ObjectToCharSequence("Download one of the following JDKs. Note that OpenJDK 11+ requires Windows 64 bit."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="cs.Append(\"OpenJDK 14 + OpenJFX 14: \")";
_cs.Append(BA.ObjectToCharSequence("OpenJDK 14 + OpenJFX 14: "));
RDebugUtils.currentLine=131093;
 //BA.debugLineNum = 131093;BA.debugLine="cs.Clickable(\"cs\", 2).Underline.Bold.Color(Color";
_cs.Clickable(processBA,"cs",(Object)(2)).Underline().Bold().Color(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (70),(int) (130),(int) (180))).Append(BA.ObjectToCharSequence("download link.")).PopAll();
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="cs.Append(\" License: GPL + classpath exception.";
_cs.Append(BA.ObjectToCharSequence(" License: GPL + classpath exception. License permits usage in closed commercial projects."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="cs.Append(\"Download the zip and unpack it. C:\\ja";
_cs.Append(BA.ObjectToCharSequence("Download the zip and unpack it. C:\\java is a good place for it."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131097;
 //BA.debugLineNum = 131097;BA.debugLine="cs.Append(\"It is recommended to use a tool such";
_cs.Append(BA.ObjectToCharSequence("It is recommended to use a tool such as 7-Zip to unzip the large package. Windows Explorer might fail to extract it properly. Installation is not required."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131098;
 //BA.debugLineNum = 131098;BA.debugLine="cs.Append(\"Oracle JDK 8: download link (requires";
_cs.Append(BA.ObjectToCharSequence("Oracle JDK 8: download link (requires creating an account)."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="cs.Append(\"Check the Accept License Agreement bu";
_cs.Append(BA.ObjectToCharSequence("Check the Accept License Agreement button."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131100;
 //BA.debugLineNum = 131100;BA.debugLine="cs.Append(\"Download the file and install it.\" &";
_cs.Append(BA.ObjectToCharSequence("Download the file and install it."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="cs.Append(\"2. Android SDK + Required Resources\"";
_cs.Append(BA.ObjectToCharSequence("2. Android SDK + Required Resources"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131103;
 //BA.debugLineNum = 131103;BA.debugLine="cs.Append(\"You need to download two components,";
_cs.Append(BA.ObjectToCharSequence("You need to download two components, both of them do not require installation."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131104;
 //BA.debugLineNum = 131104;BA.debugLine="cs.Append(\"Download Android SDK Command line too";
_cs.Append(BA.ObjectToCharSequence("Download Android SDK Command line tools"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131105;
 //BA.debugLineNum = 131105;BA.debugLine="cs.Append(\"Make sure to read and agree to the SD";
_cs.Append(BA.ObjectToCharSequence("Make sure to read and agree to the SDK license. Click on the Windows command line tools to see the license."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131106;
 //BA.debugLineNum = 131106;BA.debugLine="cs.Append(\"Android Studio is not needed and will";
_cs.Append(BA.ObjectToCharSequence("Android Studio is not needed and will not be affected by the command line tools (which are always required)."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131107;
 //BA.debugLineNum = 131107;BA.debugLine="cs.Append(\"Unzip it in a folder such as C:\\Andro";
_cs.Append(BA.ObjectToCharSequence("Unzip it in a folder such as C:\\Android"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131108;
 //BA.debugLineNum = 131108;BA.debugLine="cs.Append(\"Download the required resources.\" & C";
_cs.Append(BA.ObjectToCharSequence("Download the required resources."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131109;
 //BA.debugLineNum = 131109;BA.debugLine="cs.Append(\"Unzip in the same folder. It should l";
_cs.Append(BA.ObjectToCharSequence("Unzip in the same folder. It should look like this:"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131111;
 //BA.debugLineNum = 131111;BA.debugLine="cs.Append(\"Note that you don't need to run B4A S";
_cs.Append(BA.ObjectToCharSequence("Note that you don't need to run B4A Sdk Manager, unless you want to use the Android emulator, which is less recommended."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131112;
 //BA.debugLineNum = 131112;BA.debugLine="cs.Append(\"These are two large zip files. It is";
_cs.Append(BA.ObjectToCharSequence("These are two large zip files. It is recommended to use a tool such as 7-Zip to unzip them. We see many cases where Windows built-in zip tool fails to extract the files properly."+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))));
RDebugUtils.currentLine=131115;
 //BA.debugLineNum = 131115;BA.debugLine="cs.EnableClickEvents(EditText1)";
_cs.EnableClickEvents((android.widget.TextView)(mostCurrent._edittext1.getObject()));
RDebugUtils.currentLine=131116;
 //BA.debugLineNum = 131116;BA.debugLine="EditText1.Text = cs";
mostCurrent._edittext1.setText(BA.ObjectToCharSequence(_cs.getObject()));
 } 
       catch (Exception e37) {
			processBA.setLastException(e37);RDebugUtils.currentLine=131119;
 //BA.debugLineNum = 131119;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.LogImpl("3131119",BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)),0);
 };
RDebugUtils.currentLine=131121;
 //BA.debugLineNum = 131121;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null));}
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static void  _cs_click(Object _tag) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "cs_click", false))
	 {Debug.delegate(mostCurrent.activityBA, "cs_click", new Object[] {_tag}); return;}
ResumableSub_cs_Click rsub = new ResumableSub_cs_Click(null,_tag);
rsub.resume(processBA, null);
}
public static class ResumableSub_cs_Click extends BA.ResumableSub {
public ResumableSub_cs_Click(b4a.example.main parent,Object _tag) {
this.parent = parent;
this._tag = _tag;
}
b4a.example.main parent;
Object _tag;
int _result = 0;
anywheresoftware.b4a.phone.Phone.PhoneIntents _p = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="main";

    while (true) {
try {

        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Try";
if (true) break;

case 1:
//try
this.state = 12;
this.catchState = 11;
this.state = 3;
if (true) break;

case 3:
//C
this.state = 4;
this.catchState = 11;
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Log($\"You have clicked on word: ${Tag}\"$)";
anywheresoftware.b4a.keywords.Common.LogImpl("3393218",("You have clicked on word: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",_tag)+""),0);
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="If 1 = Tag Then";
if (true) break;

case 4:
//if
this.state = 9;
if (1==(double)(BA.ObjectToNumber(_tag))) { 
this.state = 6;
}else 
{RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="else if 2 = Tag Then";
if (2==(double)(BA.ObjectToNumber(_tag))) { 
this.state = 8;
}}
if (true) break;

case 6:
//C
this.state = 9;
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="MsgboxAsync(\"www.b4x.com\", \"go to page\")";
anywheresoftware.b4a.keywords.Common.MsgboxAsync(BA.ObjectToCharSequence("www.b4x.com"),BA.ObjectToCharSequence("go to page"),processBA);
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="Wait For Msgbox_Result (Result As Int)";
anywheresoftware.b4a.keywords.Common.WaitFor("msgbox_result", processBA, new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "main", "cs_click"), null);
this.state = 13;
return;
case 13:
//C
this.state = 9;
_result = (Integer) result[0];
;
 if (true) break;

case 8:
//C
this.state = 9;
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="Dim p As PhoneIntents";
_p = new anywheresoftware.b4a.phone.Phone.PhoneIntents();
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="StartActivity(p.OpenBrowser(\"https://www.b4x.co";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(_p.OpenBrowser("https://www.b4x.com/b4j/files/java/jdk-14.0.1.zip")));
 if (true) break;

case 9:
//C
this.state = 12;
;
 if (true) break;

case 11:
//C
this.state = 12;
this.catchState = 0;
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.LogImpl("3393228",BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)),0);
 if (true) break;
if (true) break;

case 12:
//C
this.state = -1;
this.catchState = 0;
;
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="End Sub";
if (true) break;
}} 
       catch (Exception e0) {
			
if (catchState == 0)
    throw e0;
else {
    state = catchState;
processBA.setLastException(e0);}
            }
        }
    }
}
}